---
title: Papers
keywords: papers
---

# Articles 

[All papers citing the SPE article](https://scholar.google.com/scholar?hl=en&as_sdt=0,5&sciodt=0,5&cites=18020575005067751853&scipsc=&q=&scisbd=1)

Durieux, Thomas, et al. "[Dynamic patch generation for null pointer exceptions using metaprogramming.](https://hal.archives-ouvertes.fr/hal-01419861/document)" Software Analysis, Evolution and Reengineering (SANER), 2017 IEEE 24th International Conference on. IEEE, 2017.

Long, Fan, Peter Amidon, and Martin Rinard. "[Automatic inference of code transforms for patch generation.](http://people.csail.mit.edu/rinard/paper/fse17.genesis.pdf)" Proceedings of the 2017 11th Joint Meeting on Foundations of Software Engineering, ESEC/FSE. Vol. 2017. 2017.

Feist, Michael D., et al. "[Visualizing Project Evolution through Abstract Syntax Tree Analysis.](http://softwareprocess.es/pubs/feist2016VISSOFT-syntax-tree.pdf)" Software Visualization (VISSOFT), 2016 IEEE Working Conference on. IEEE, 2016.

Carette, Antonin, et al. "[Investigating the energy impact of android smells.](https://hal.inria.fr/hal-01403485/document)" Software Analysis, Evolution and Reengineering (SANER), 2017 IEEE 24th International Conference on. IEEE, 2017.

Lelli, Valeria, et al. "[Automatic detection of GUI design smells: The case of blob listener.](https://hal-centralesupelec.archives-ouvertes.fr/hal-01308625/document)" Proceedings of the 8th ACM SIGCHI Symposium on Engineering Interactive Computing Systems. ACM, 2016.

[Partitioners Track: Generating Security Vulnerabilities in
Source Code](https://pdfs.semanticscholar.org/8805/3bf61a22821f25e8ce1f8b446330c6b4f586.pdf) (Felix Schuckert), In Sicherheit 2016. 

[Casper: Automatic Tracking of Null Dereferences to Inception with Causality Traces](https://hal.archives-ouvertes.fr/hal-01354090/document) (Benoit Cornu, Earl T. Barr, Martin Monperrus and Lionel Seinturier), In Journal of Systems and Software, Elsevier, 2016.

[Controlling the granularity of automatic parallel programs](http://www.sciencedirect.com/science/article/pii/S1877750316301065) (Fonseca, A., Cabral, B., Rafael, J., & Correia, I.) Journal of Computational Science, 2016.

[Automatic Parallelization: Executing Sequential Programs on a Task-Based Parallel Runtime](http://arxiv.org/pdf/1604.03211) (Fonseca, A., Cabral, B., Rafael, J., & Correia, I.) International Journal of Parallel Programming, Vol. 44, Issue 6, 2016.

[ASTOR: A Program Repair Library for Java](https://hal.archives-ouvertes.fr/hal-01321615/document) (Matias Martinez and Martin Monperrus), In Proceedings of ISSTA, Demonstration Track, 2016. (<https://github.com/SpoonLabs/astor>)

[Mutation-Based Graph Inference for Fault Localization](https://hal.inria.fr/hal-01350515/document) (Vincenzo Musco, Martin Monperrus and Philippe Preux), In International Working Conference on Source Code Analysis and Manipulation, 2016.

[TTC'2015 Case: Refactoring Java Programs using Spoon](https://hal.inria.fr/hal-01185189/document) (Gérard Paligot, Nicolas Petitprez and Martin Monperrus), In Proceedings of the 2015 Transformation Tool Contest, 2015

[SWIN: Towards Type-Safe Java Program Adaptation between APIs](http://sei.pku.edu.cn/~xiongyf04/papers/PEPM15.pdf) (Li, Jun, et al.) Proceedings of the 2015 Workshop on Partial Evaluation and Program Manipulation. 2015.

[Test Case Purification for Improving Fault Localization](https://hal.inria.fr/hal-01061911/PDF/main.pdf) (Jifeng Xuan, Martin Monperrus), In Proceedings of the International Symposium on the Foundations of Software Engineering, 2014.

[B-Refactoring: Automatic Test Code Refactoring to Improve Dynamic Analysis](https://hal.archives-ouvertes.fr/hal-01309004/document) (Jifeng Xuan, Benoit Cornu, Matias Martinez, Benoit Baudry, Lionel Seinturier and Martin Monperrus), In Information and Software Technology, Elsevier, 2016. (<https://github.com/Spirals-Team/banana-refactoring>)

[Exception Handling Analysis and Transformation Using Fault Injection: Study of Resilience Against Unanticipated Exceptions](https://hal.inria.fr/hal-01062969/document) (Benoit Cornu, Lionel Seinturier, Martin Monperrus), In Information and Software Technology, Elsevier, 2014. 

[Automatic Repair of Buggy If Conditions and Missing Preconditions with SMT](https://hal.inria.fr/hal-00977798/PDF/NOPOL-Automatic-Repair-of-Buggy-If-Conditions-and-Missing-Preconditions-with-SMT.pdf) (Favio DeMarco, Jifeng Xuan, Daniel Le Berre, Martin Monperrus), In Proceedings of the 6th International Workshop on Constraints in Software Testing, Verification, and Analysis (CSTVA 2014), 2014.

[Tailored Source Code Transformations to Synthesize Computationally Diverse Program Variants](https://hal.inria.fr/hal-00938855/PDF/sosies.pdf) (Benoit Baudry, Simon Allier, Martin Monperrus), In Proceedings of the International Symposium on Software Testing and Analysis, 2014.

[Æminiumgpu: an intelligent framework for gpu programming](https://www.researchgate.net/profile/Bruno_Cabral/publication/231238601_AEminiumGPU_An_Intelligent_Framework_for_GPU_Programming/links/0fcfd5066bca093c32000000.pdf) (Fonseca, Alcides and Cabral, Bruno) Facing the Multicore-Challenge III, 2012.

[Remodularizing Java programs for improved locality of feature implementations in source code.](https://findresearcher.sdu.dk:8443/ws/files/49141761/B1FADd01.pdf) (Olszak, Andrzej, and Bo Nørregaard Jørgensen) Science of Computer Programming 77.3, 2012.

[AVal: an Extensible Attribute-Oriented Programming Validator for Java](https://hal.inria.fr/inria-00180333/file/AVal.pdf) (Noguera, C., Pawlak R.), In 6th IEEE International Workshop on Source Code Analysis and Manipulation (SCAM'06), Philadelphia, PA, USA, September 2006.

[Using Attribute-Oriented Programming to Leverage Fractal-Based Developments](https://hal.inria.fr/hal-01353552) (Rouvoy, R., Pessemier, N., Pawlak, R., Merle, P.), In 5th International ECOOP Workshop on Fractal Component Model, Nantes, France, July 2006.

[Spoon: Program Analysis and Transformation in Java.](http://hal.inria.fr/inria-00071366) (Pawlak, R., Noguera, C., Petitprez, N.), INRIA Research Report #5901, May 2006.

[Spoon: Compile-time Annotation Processing for Middleware](https://www.computer.org/csdl/magazine/ds/2006/11/oy001/13rRUxASu7G) (Pawlak R.), IEEE Distributed Systems Online, vol. 7, no. 11, 2006, art. no. 0611-oy001

[Spoon: Annotation-Driven Program Transformation - The AOP Case](http://middleware05.objectweb.org/WSProceedings/AOMD05/a6-pawlak.pdf) (Pawlak, R.), First Workshop on Aspect-Orientation for Middleware Development. Middleware 2005, Grenoble, France.

# Dissertations

[Automated Grading of Java Assignments](http://dspace.library.uu.nl/bitstream/handle/1874/337629/Master%20Thesis%203700607%20(final%20version).pdf) (Nadia Boudewijn), Universiteit Utrecht, 2016

[Semi-automatic code-to-code transformer for Java: Transformation of library calls](http://liu.diva-portal.org/smash/get/diva2:944700/FULLTEXT01.pdf) (Boije, Niklas and Borg, Kristoffer ), Linköping University, 2016 

[Automatic Analysis and Repair of Exception Bugs for Java Programs](https://tel.archives-ouvertes.fr/tel-01250092v1) (Benoit Cornu), PhD Thesis, University of Lille, 2015.

[AeminiumGPU – A CPU-GPU Hybrid Runtime for the Aeminium Language](http://aeminium.dei.uc.pt/images/7/73/Alcides_fonseca_msc_thesis.pdf) (Fonseca, Alcides), University of Coimbra, 2011 

# Presentations

2016-07-07 [Code Transformation with Spoon](http://fr.slideshare.net/GrardPaligot/code-transformation-with-spoon), PADR Talk (France, Lille).

